/*
Author: Nart Schinackow

Comiler Used : MikroC

Description :
Pic16f877a running at 10MHZ
this code is a simple demo of a counter from 0-15, the library displays the count
on a 4 digit 7-segment.
if you want to change the number of segments to be displayed, 
consult the data sheet for the scan limit register.
change the value of the scan limit register.

Notes:
This Is MAX7219 SOFTWARE VERSION, meaning no need to use hardware SPI!
feel free to use any pic pins.
*/


#include "SoftMax7219.h"

sfr sbit MAX7219_SDO at RB5_bit;
sfr sbit MAX7219_SDI at RB6_bit;
sfr sbit MAX7219_SCK at RB7_bit;
sfr sbit MAX7219_CS at RC0_bit;


sfr sbit MAX7219_SDO_DIRECTION at TRISB5_bit;
sfr sbit MAX7219_SDI_DIRECTION at TRISB6_bit;
sfr sbit MAX7219_SCK_DIRECTION at TRISB7_bit;
sfr sbit MAX7219_CS_DIRECTION at TRISC0_bit;





unsigned int i;


void main() 
{
  SoftDisplay.Init(0x0f,0x0f,0x03,0x01);// Initialize Software Max7219
  SoftDisplay.Print(0,4);// Put Initial Value To Display for 4 seven segemnts
  
  SoftDisplay.ChangeIntensity(1);//low brightness for one second
  delay_ms(1000);
  SoftDisplay.ChangeIntensity(15);//high brightness for one second
  delay_ms(1000);
  
  for(i=0;i<10;i++)// Blink Display 10 Times
  {
    SoftDisplay.TurnOff();
    delay_ms(100);
    SoftDisplay.TurnOn();
    delay_ms(100);
  }
  
  while(1)// loop forever
  {
    for(i=0;i<512;i++)//Count From 0 To 511 And Display on 4 Seven segemnts
    {
      SoftDisplay.Print(i,4);
      delay_ms(100);
    }
  }

}