#line 1 "C:/Documents and Settings/Nart Schinackow/Desktop/105__software_version__max7219_seven_segment_wrapped_library_v1.0.0.0/SoftWare Max7219 Project/MyProject.c"
#line 1 "c:/documents and settings/nart schinackow/desktop/105__software_version__max7219_seven_segment_wrapped_library_v1.0.0.0/software max7219 project/softmax7219.h"
extern sfr sbit MAX7219_SDO;
extern sfr sbit MAX7219_SDI;
extern sfr sbit MAX7219_SCK;
extern sfr sbit MAX7219_CS;


extern sfr sbit MAX7219_SDO_DIRECTION;
extern sfr sbit MAX7219_SDI_DIRECTION;
extern sfr sbit MAX7219_SCK_DIRECTION;
extern sfr sbit MAX7219_CS_DIRECTION;

void SoftMax7219UpdateIntensity(char OnValue);
void SoftMax7219DisplayOn();
void SoftMax7219DisplayOff();
void SoftMax7219Print(unsigned long Number, unsigned short NumberOfDigits);
void SoftMax7219Init(char CodeB, char Intensity, char ScanLimit, char ShutDown);
void Soft7219SpiWriteByte(char DataByte);
char Soft7219SpiReadByte(char Clock);





struct SoftMax7219Struct
{
 void (*Init)(char CodeB, char Intensity, char ScanLimit, char ShutDown);
 void (*Print)(unsigned long Number, unsigned short NumberOfDigits);
 void (*TurnOff)();
 void (*TurnOn)();
 void (*ChangeIntensity)(char OnValue);
}SoftDisplay={&SoftMax7219Init,&SoftMax7219Print,&SoftMax7219DisplayOff,&SoftMax7219DisplayOn,&SoftMax7219UpdateIntensity};
#line 1 "c:/documents and settings/nart schinackow/desktop/105__software_version__max7219_seven_segment_wrapped_library_v1.0.0.0/software max7219 project/softmax7219spi.c"
void Soft7219SpiWriteByte(char DataByte)
{
char ret;
unsigned char mask;

MAX7219_SCK=0;
mask = 0x80;
ret = 0;

do {
MAX7219_SDO=0;
if (DataByte & mask)MAX7219_SDO=1;
MAX7219_SCK=1;
if (MAX7219_SDI) ret |= mask;
delay_us(1);
MAX7219_SCK=0;
mask = mask >> 1;
delay_us(1);
} while (mask != 0);


}


char Soft7219SpiReadByte(char Clock)
{
char ret;
unsigned char mask;

MAX7219_SCK=0;
mask = 0x80;
ret = 0;

do {
MAX7219_SDO=0;
if (Clock & mask)MAX7219_SDO=1;
MAX7219_SCK=1;
if (MAX7219_SDI) ret |= mask;
delay_us(1);
MAX7219_SCK=0;
mask = mask >> 1;
delay_us(1);
} while (mask != 0);

return ret;
}
#line 1 "c:/documents and settings/nart schinackow/desktop/105__software_version__max7219_seven_segment_wrapped_library_v1.0.0.0/software max7219 project/softmax7219.c"
void SoftMax7219Init(char CodeB, char Intensity, char ScanLimit, char ShutDown)
{
 MAX7219_CS=1;
 MAX7219_SDO=0;
 MAX7219_SDI=0;
 MAX7219_SCK=0;
 MAX7219_CS_DIRECTION=0;
 MAX7219_SDO_DIRECTION=0;
 MAX7219_SDI_DIRECTION=1;
 MAX7219_SCK_DIRECTION=0;

 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x09);
 Soft7219SpiWriteByte(CodeB);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0a);
 Soft7219SpiWriteByte(Intensity);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0b);
 Soft7219SpiWriteByte(ScanLimit);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0c);
 Soft7219SpiWriteByte(ShutDown);
 MAX7219_CS=1;

 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x00);
 Soft7219SpiWriteByte(0xff);
 MAX7219_CS=1;
}

void SoftMax7219Print(unsigned long Number, unsigned short NumberOfDigits)
{
 short i;
 for(i=1;Number>0||i-NumberOfDigits<=0;Number/=10,i++)
 {
 MAX7219_CS=0;
 Soft7219SpiWriteByte(i);
 Soft7219SpiWriteByte(Number%10);
 MAX7219_CS=1;
 }
}


void SoftMax7219DisplayOff()
{
 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0c);
 Soft7219SpiWriteByte(0x00);
 MAX7219_CS=1;
}

void SoftMax7219DisplayOn()
{
 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0c);
 Soft7219SpiWriteByte(0x01);
 MAX7219_CS=1;
}

void SoftMax7219UpdateIntensity(char OnValue)
{
 if(OnValue>=0&&OnValue<=15)
 {
 MAX7219_CS=0;
 Soft7219SpiWriteByte(0x0a);
 Soft7219SpiWriteByte(OnValue);
 MAX7219_CS=1;
 }
}
#line 22 "C:/Documents and Settings/Nart Schinackow/Desktop/105__software_version__max7219_seven_segment_wrapped_library_v1.0.0.0/SoftWare Max7219 Project/MyProject.c"
sfr sbit MAX7219_SDO at RB5_bit;
sfr sbit MAX7219_SDI at RB6_bit;
sfr sbit MAX7219_SCK at RB7_bit;
sfr sbit MAX7219_CS at RC0_bit;


sfr sbit MAX7219_SDO_DIRECTION at TRISB5_bit;
sfr sbit MAX7219_SDI_DIRECTION at TRISB6_bit;
sfr sbit MAX7219_SCK_DIRECTION at TRISB7_bit;
sfr sbit MAX7219_CS_DIRECTION at TRISC0_bit;





unsigned int i;


void main()
{
 SoftDisplay.Init(0x0f,0x0f,0x03,0x01);
 SoftDisplay.Print(0,4);

 SoftDisplay.ChangeIntensity(1);
 delay_ms(1000);
 SoftDisplay.ChangeIntensity(15);
 delay_ms(1000);

 for(i=0;i<10;i++)
 {
 SoftDisplay.TurnOff();
 delay_ms(100);
 SoftDisplay.TurnOn();
 delay_ms(100);
 }

 while(1)
 {
 for(i=0;i<512;i++)
 {
 SoftDisplay.Print(i,4);
 delay_ms(100);
 }
 }

}
