extern sfr sbit MAX7219_SDO;
extern sfr sbit MAX7219_SDI;
extern sfr sbit MAX7219_SCK;
extern sfr sbit MAX7219_CS;


extern sfr sbit MAX7219_SDO_DIRECTION;
extern sfr sbit MAX7219_SDI_DIRECTION;
extern sfr sbit MAX7219_SCK_DIRECTION;
extern sfr sbit MAX7219_CS_DIRECTION;

void SoftMax7219UpdateIntensity(char OnValue);
void SoftMax7219DisplayOn();
void SoftMax7219DisplayOff();
void SoftMax7219Print(unsigned long Number, unsigned short NumberOfDigits);
void SoftMax7219Init(char CodeB, char Intensity, char ScanLimit, char ShutDown);
void Soft7219SpiWriteByte(char DataByte);
char Soft7219SpiReadByte(char Clock);





struct SoftMax7219Struct
{
  void (*Init)(char CodeB, char Intensity, char ScanLimit, char ShutDown);
  void (*Print)(unsigned long Number, unsigned short NumberOfDigits);
  void (*TurnOff)();
  void (*TurnOn)();
  void (*ChangeIntensity)(char OnValue);
}SoftDisplay={&SoftMax7219Init,&SoftMax7219Print,&SoftMax7219DisplayOff,&SoftMax7219DisplayOn,&SoftMax7219UpdateIntensity};



#include "SoftMax7219Spi.c"
#include "SoftMax7219.c"